//= require <dSS/system/logfiles>
//= require <dSS/system/jsLogFiles>

Ext.namespace('dSS');

dSS.SystemPanel = Ext.extend(Ext.Panel, {
    initComponent: function() {

        var TabRecord = Ext.data.Record.create([
        {
            name: "title"
        }]);

        var tabStore = new Ext.data.Store({},
        TabRecord);

        var contentPanel = {
            ref: 'contentPanel',
            region: 'center',
            layout: 'card',
            hideBorders: true,
            border: true,
            activeItem: 0,
            items: [
            {
                title: dSS._("Property Tree"),
                xtype: 'dsssystempropertytree',
                ref: 'systemPropertyTree'
            },
            {
                title: dSS._("Access authorization"),
                xtype: 'dsstokenauthpanel'
            },
            {
                title: dSS._("Logfiles"),
                xtype: 'systemlogfiles',
                ref: 'systemlogfiles'
            },
            {
                title: dSS._("JS Plugin Logs"),
                xtype: "dsssystemjslogfiles",
                ref: "systemjslogfiles"
            }]
        };

        this.listView = new Ext.list.ListView({
            ref: 'listView',
            store: tabStore,
            singleSelect: true,
            region: 'west',
            hideHeaders: true,
            columns: [
            {
                header: 'name',
                dataIndex: 'title'
            }]
        });

        var listHolder = new Ext.Panel({
            title: "System",
            region: 'west',
            layout: 'fit',
            split: true,
            width: 225,
            minSize: 175,
            maxSize: 400,
            items: [this.listView]
        });

        Ext.apply(this, {
            layout: 'border',
            border: false,
            bodyBorder: false,
            items: [listHolder, contentPanel]
        });

        dSS.SystemPanel.superclass.initComponent.apply(this, arguments);

        this.on('activate', function(component) {
            if (this.initializedTabs) {
                this.contentPanel.layout.activeItem.fireEvent("activate", this.contentPanel.layout.activeItem);
                return;
            }
            // for each item in contentPanel
            this.contentPanel.items.each(function(item) {
                var tab = new TabRecord({
                    title: item.title
                });
                tabStore.add([tab]);
            },
            this);
            this.listView.select(0, false, true);
            this.listView.on('activate', function() {
                // setup new filter when panel gets reactivated
            },
            this);
            this.listView.on('selectionchange', function(listView, selections) {
                this.contentPanel.layout.setActiveItem(selections[0].viewIndex);
                this.contentPanel.layout.activeItem.fireEvent("activate", this.contentPanel.layout.activeItem);
            },
            this);
            this.initializedTabs = true;
        },
        this);
    }
});

Ext.reg('dsssystempanel', dSS.SystemPanel);

